diff --git a/drivers/hid/amd-sfh-hid/hid_descriptor/amd_sfh_hid_report_desc.h b/drivers/hid/amd-sfh-hid/hid_descriptor/amd_sfh_hid_report_desc.h
index 8d97ca0f9b526..b07dc4bbb858a 100644
--- a/drivers/hid/amd-sfh-hid/hid_descriptor/amd_sfh_hid_report_desc.h
+++ b/drivers/hid/amd-sfh-hid/hid_descriptor/amd_sfh_hid_report_desc.h
@@ -1,6 +1,6 @@
 /* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
- * HID  descriptor stuructures
+ * HID  descriptor structures
  * Copyright 2020-2021 Advanced Micro Devices, Inc.
  * Authors: Nehal Bakulchandra Shah <Nehal-bakulchandra.shah@amd.com>
  *	    Sandeep Singh <Sandeep.singh@amd.com>
@@ -429,21 +429,21 @@ const u8 comp3_report_descriptor[] = {
 0x95, 1,		/* HID report count(1) */
 0x55, 0x0F,		/* HID unit exponent(0x0F) */
 0xB1, 0x02,		/* HID feature (Data_Arr_Abs) */
-0x0A, 0x84, 0x14,	/* Maganetic flux and change sensitivity ABS) */
+0x0A, 0x84, 0x14,	/* Magnetic flux and change sensitivity ABS) */
 0x15, 0,		/* HID logical Min_8(0) */
 0x26, 0xFF, 0xFF,	/* HID logical Max_16(0xFF,0xFF) */
 0x75, 16,		/* HID report size(16) */
 0x95, 1,		/* HID report count(1) */
 0x55, 0x0E,		/* HID unit exponent(0x0E) */
 0xB1, 0x02,		/* HID feature (Data_Arr_Abs) */
-0x0A, 0x84, 0x24,	/* Maganetic flux and mod change sensitivity Max) */
+0x0A, 0x84, 0x24,	/* Magnetic flux and mod change sensitivity Max) */
 0x16, 0x01, 0x80,	/* HID logical Min_16(0x01,0x80) */
 0x26, 0xFF, 0x7F,	/* HID logical Max_16(0xFF,0x7F) */
 0x75, 16,		/* HID report size(16) */
 0x95, 1,		/* HID report count(1) */
 0x55, 0x0F,		/* HID unit exponent(0x0F) */
 0xB1, 0x02,		/* HID feature (Data_Arr_Abs) */
-0x0A, 0x84, 0x34,	/* Maganetic flux and mod change sensitivity Min */
+0x0A, 0x84, 0x34,	/* Magnetic flux and mod change sensitivity Min */
 0x16, 0x01, 0x80,	/* HID logical Min_16(0x01,0x80) */
 0x26, 0xFF, 0x7F,	/* HID logical Max_16(0xFF,0x7F) */
 0x75, 16,		/* HID report size(16) */
diff --git a/drivers/hid/hid-logitech-hidpp.c b/drivers/hid/hid-logitech-hidpp.c
index 81de88ab2ecc7..68f9e9d207f42 100644
--- a/drivers/hid/hid-logitech-hidpp.c
+++ b/drivers/hid/hid-logitech-hidpp.c
@@ -1694,7 +1694,7 @@ static int hidpp_battery_get_property(struct power_supply *psy,
 			val->strval = hidpp->hid_dev->uniq;
 			break;
 		case POWER_SUPPLY_PROP_VOLTAGE_NOW:
-			/* hardware reports voltage in in mV. sysfs expects uV */
+			/* hardware reports voltage in mV. sysfs expects uV */
 			val->intval = hidpp->battery.voltage * 1000;
 			break;
 		case POWER_SUPPLY_PROP_CHARGE_TYPE:
diff --git a/drivers/hid/hid-magicmouse.c b/drivers/hid/hid-magicmouse.c
index 664a624a363d0..f6790dc6fd026 100644
--- a/drivers/hid/hid-magicmouse.c
+++ b/drivers/hid/hid-magicmouse.c
@@ -869,7 +869,7 @@ static int magicmouse_probe(struct hid_device *hdev,
 	report->size = 6;
 
 	/*
-	 * Some devices repond with 'invalid report id' when feature
+	 * Some devices respond with 'invalid report id' when feature
 	 * report switching it into multitouch mode is sent to it.
 	 *
 	 * This results in -EIO from the _raw low-level transport callback,
diff --git a/drivers/hid/hid-nintendo.c b/drivers/hid/hid-nintendo.c
index 2204de889739f..0eb017333bca6 100644
--- a/drivers/hid/hid-nintendo.c
+++ b/drivers/hid/hid-nintendo.c
@@ -1071,7 +1071,7 @@ static void joycon_parse_imu_report(struct joycon_ctlr *ctlr,
 	 * samples, so the IMU sampling rate should be avg_time_delta/3. We can
 	 * also use this average to detect events where we have dropped a
 	 * packet. The userspace timestamp for the samples will be adjusted
-	 * accordingly to prevent unwanted behvaior.
+	 * accordingly to prevent unwanted behavior.
 	 */
 	if (!ctlr->imu_first_packet_received) {
 		ctlr->imu_timestamp_us = 0;
diff --git a/drivers/hid/hid-redragon.c b/drivers/hid/hid-redragon.c
index 73c9d4c4fa34d..b32ac27940b29 100644
--- a/drivers/hid/hid-redragon.c
+++ b/drivers/hid/hid-redragon.c
@@ -1,8 +1,8 @@
+// SPDX-License-Identifier: GPL-2.0+
 /*
  *  HID driver for Redragon keyboards
  *
  *  Copyright (c) 2017 Robert Munteanu
- *  SPDX-License-Identifier: GPL-2.0+
  */
 
 /*
diff --git a/drivers/hid/hid-roccat-kone.c b/drivers/hid/hid-roccat-kone.c
index 76da04801ca9b..2ba5cc5a1ab6a 100644
--- a/drivers/hid/hid-roccat-kone.c
+++ b/drivers/hid/hid-roccat-kone.c
@@ -688,7 +688,7 @@ static int kone_init_kone_device_struct(struct usb_device *usb_dev,
  * Since IGNORE_MOUSE quirk moved to hid-apple, there is no way to bind only to
  * mousepart if usb_hid is compiled into the kernel and kone is compiled as
  * module.
- * Secial behaviour is bound only to mousepart since only mouseevents contain
+ * Special behaviour is bound only to mousepart since only mouseevents contain
  * additional notifications.
  */
 static int kone_init_specials(struct hid_device *hdev)
@@ -835,7 +835,7 @@ static void kone_report_to_chrdev(struct kone_device const *kone,
 
 /*
  * Is called for keyboard- and mousepart.
- * Only mousepart gets informations about special events in its extended event
+ * Only mousepart gets information about special events in its extended event
  * structure.
  */
 static int kone_raw_event(struct hid_device *hdev, struct hid_report *report,
diff --git a/drivers/hid/hid-sony.c b/drivers/hid/hid-sony.c
index 60ec2b29d54de..03691cdcfb8e1 100644
--- a/drivers/hid/hid-sony.c
+++ b/drivers/hid/hid-sony.c
@@ -368,7 +368,7 @@ static const unsigned int buzz_keymap[] = {
 };
 
 /* The Navigation controller is a partial DS3 and uses the same HID report
- * and hence the same keymap indices, however not not all axes/buttons
+ * and hence the same keymap indices, however not all axes/buttons
  * are physically present. We use the same axis and button mapping as
  * the DS3, which uses the Linux gamepad spec.
  */
diff --git a/drivers/hid/intel-ish-hid/ishtp-hid-client.c b/drivers/hid/intel-ish-hid/ishtp-hid-client.c
index 4338c9b68a43d..e3d70c5460e96 100644
--- a/drivers/hid/intel-ish-hid/ishtp-hid-client.c
+++ b/drivers/hid/intel-ish-hid/ishtp-hid-client.c
@@ -328,7 +328,7 @@ static void process_recv(struct ishtp_cl *hid_ishtp_cl, void *recv_buf,
 
 /**
  * ish_cl_event_cb() - bus driver callback for incoming message/packet
- * @device:	Pointer to the the ishtp client device for which this message
+ * @device:	Pointer to the ishtp client device for which this message
  *		is targeted
  *
  * Remove the packet from the list and process the message by calling